#include <iostream.h>

class Node
{
	public:
	Node();
	virtual ~Node();
	virtual void ShowValue ()const =0;
	virtual Node* InsertNode (int)=0;
//      virtual int GetValue () const {return 0;}
};
Node::Node()
{}

Node::~Node()
{}




class InternalNode: public Node
{
	public:
	InternalNode(int , Node*);
	virtual ~InternalNode() {delete itsNext;}
	virtual void ShowValue() const{cout << itsValue; itsNext->ShowValue();}
	virtual Node* InsertNode (int);
	int GetValue () const {return itsValue;}
	protected:
	Node* itsNext;
	int itsValue;
};


InternalNode::InternalNode(int value, Node* next):
itsNext(next),
itsValue (value)
{
}

Node* InternalNode::InsertNode (int value)
{
	if (value >= itsValue)
	{
		Node* bigNode = new InternalNode(value,this);
		return bigNode;
	}
	else
	{
		itsNext=itsNext->InsertNode(value);
		return this;
	}
}

// Klasa Repni Cvor
class TailNode: public Node
{
	public:
	TailNode(){}
	~TailNode(){}
	void ShowValue()const{}
	virtual Node* InsertNode(int);
};

Node* TailNode::InsertNode(int value)
{
	Node* node= new InternalNode(value,this);
	return node;
}

//Glavna Klasa
class HeadNode: public Node
{
	public:
	HeadNode();
	virtual ~HeadNode(){delete itsNext;}
	void ShowValue ()const{itsNext->ShowValue();}
	virtual Node* InsertNode (int);
	private:
        Node* itsNext;
};

//
HeadNode::HeadNode()
{
	Node* itsNext = new TailNode;
}

Node* HeadNode::InsertNode (int value)
{
	itsNext = itsNext->InsertNode(value);
	return this;
}


//Klasa LIST
class List
{
	public:
	List();
	~List(){delete itsHeadNode;}
	void ShowAll () const{ itsHeadNode->ShowValue();}
	Node* InsertNode(int);
	private:
	Node* itsHeadNode;
};

List::List()
{
	itsHeadNode= new HeadNode;
}

Node* List::InsertNode (int value)
{
	itsHeadNode->InsertNode(value);
}

int main()
{
	List ll;
	int value;

	for (;;)
	{
		cout << "Unesite bilo koji broj unesite 0 za prekid: ";
		cin >> value;
		if (!value)
			break;
		ll.InsertNode(value);
	}
	ll.ShowAll();
	return 0;
}
		

	
	

	

